<template>
  <article class="view view--identiy-public-create-user">
    <VForm
      name="public-create-user-form"
      :fields="fields"
      :modelState="modelState"
      buttonText="Create"
      buttonIconClass="bi bi-save-fill"
      :busy="creating"
      busyButtonText="Creating..."
      @submit="onSubmit"
    />
  </article>
</template>

<script>
import { ref } from 'vue'
import { useRouter } from 'vue-router'
import { VForm, useApi, useNotification } from '../../../core'
import UsersApi from '../../api/users-api'
import { useAuth } from '../../plugins/auth-plugin.js'

export default {
  name: 'IdentityPublicCreateUserView',
  components: {
    VForm,
  },
  setup() {
    const router = useRouter()
    const api = useApi()
    const auth = useAuth()
    const notify = useNotification()
    const usersApi = new UsersApi(api, auth)

    const fields = ref([
      {
        type: 'text',
        name: 'username',
        label: 'Username',
        maxlength: 50,
        validate: 'required|alpha_num|uniqueusername',
        value: '',
      },
      {
        type: 'password',
        name: 'password',
        label: 'Password',
        maxlength: 255,
        validate: 'required|min:8',
        value: '',
      },
      {
        type: 'password',
        name: 'confirmPassword',
        label: 'Confirm password',
        maxlength: 255,
        validate: 'confirmed:password',
        value: '',
      },
      {
        type: 'email',
        name: 'email',
        label: 'Email',
        maxlength: 255,
        validate: 'required|uniqueemail|email',
        value: '',
      },
      // TODO: Configire create/update fields.
      //...userAddOn.formFields.map((x) => ({ ...x.field, value: '' })),
      {
        type: 'recaptcha',
        name: 'reCaptcha',
      },
    ])

    const modelState = ref({})
    const creating = ref(false)

    const onSubmit = async (form) => {
      creating.value = true

      try {
        await usersApi.createAsync(form)
        router.push({
          name: 'identity-public-email-verification',
          query: { usernameOrEmail: form.username },
        })
        notify.success('Account successfully created.')
      } catch (ex) {
        if (ex.response?.data?.modelState) {
          modelState.value = ex.response.data.modelState
        } else if (ex.response?.data?.message) {
          notify.error('', ex)
        } else {
          notify.error('There was a problem creating your account.', ex)
        }
      } finally {
        creating.value = false
      }
    }

    return {
      fields,
      modelState,
      creating,
      onSubmit,
    }
  },
}
</script>
